#include"main.h"
#include<math.h>

const uint8_t blur[5][5]=
{
	{2,4,5,4,2},
	{4,9,12,9,4},
	{5,12,15,12,5},
	{4,9,12,9,4},
	{2,4,5,4,2}
};

const int8_t Dx[3][3]=
{
	{-1,0,1},
	{-2,0,2},
	{-1,0,1}
};

const int8_t Dy[3][3]=
{
	{1,2,1},
	{0,0,0},
	{-1,-2,-1}
};

void _LevyHorni(u16 x, u8 y)
{int i,j;
for (i=x-2;i<=x+2;i++)
{
for (j = y;j<=y+5;j++)
{
poleC[i][j] = 0;
}
}
poleC[x][y+2] = LH2;
}

void _PravyHorni(u16 x, u8 y)
{int i,j;
for (i=x-2;i<=x+2;i++)
{
for (j = y;j<=y+5;j++)
{
poleC[i][j] = 0;
}
}
poleC[x][y+2] = PH2;
}

void _PravyDolni(u16 x, u8 y)
{int i,j;
for (i=x-2;i<=x+2;i++)
{
for (j = y;j<=y+5;j++)
{
poleC[i][j] = 0;
}
}
poleC[x][y+2] = PD2;
}

void _LevyDolni(u16 x, u8 y)
{int i,j;
for (i=x-2;i<=x+2;i++)
{
for (j = y;j<=y+5;j++)
{
poleC[i][j] = 0;
}
}
poleC[x][y+2] = LD2;
}


void B2A(void)
{int pixel,radek;
 for (radek = 2; radek < Ymax-2; radek++)
	  	{ 
		
		 	for (pixel = 2; pixel < Xmax-2 ; pixel++)
				{
				poleA[pixel][radek] = poleB[pixel][radek];
				}
		};

}

void canny(void)
{
uint8_t Tlow,Thigh;
float tmpAngle;
	double thisAngle;
	int pixel,radek;
	signed int tmpDx,tmpDy;
 GPIO_WriteBit(GPIOB, LED1, (BitAction)0);
 for (radek = 2; radek < Ymax-2; radek++)
	  	{ 
		
		 	for (pixel = 2; pixel < Xmax-2 ; pixel++)
				{
 poleB[pixel][radek] =
 ( 							   // rozmazani
 poleA[pixel-2][radek-2]*blur[0][0]+poleA[pixel-1][radek-2]*blur[1][0]+poleA[pixel][radek-2]*blur[2][0]+poleA[pixel+1][radek-2]*blur[3][0]+poleA[pixel+2][radek-2]*blur[4][0]+
 poleA[pixel-2][radek-1]*blur[0][1]+poleA[pixel-1][radek-1]*blur[1][1]+poleA[pixel][radek-1]*blur[2][1]+poleA[pixel+1][radek-1]*blur[3][1]+poleA[pixel+2][radek-1]*blur[4][1]+ 
 poleA[pixel-2][radek-0]*blur[0][2]+poleA[pixel-0][radek-0]*blur[1][2]+poleA[pixel][radek-0]*blur[2][2]+poleA[pixel+1][radek-0]*blur[3][2]+poleA[pixel+2][radek-0]*blur[4][2]+
 poleA[pixel-2][radek+1]*blur[0][3]+poleA[pixel-1][radek+1]*blur[1][3]+poleA[pixel][radek+1]*blur[2][3]+poleA[pixel+1][radek+1]*blur[3][3]+poleA[pixel+2][radek+1]*blur[4][3]+
 poleA[pixel-2][radek+2]*blur[0][4]+poleA[pixel-1][radek+2]*blur[1][4]+poleA[pixel][radek+2]*blur[2][4]+poleA[pixel+1][radek+2]*blur[3][4]+poleA[pixel+2][radek+2]*blur[4][4]
 )/159;				
				}
		};

		B2A();

   for (radek = 2; radek < Ymax-2; radek++)
	  	{ 
		
		 	for (pixel = 2; pixel < Xmax-2 ; pixel++)	   //maska
				{
 tmpDx=
 poleA[pixel-1][radek-1]*Dx[0][0]+poleA[pixel-0][radek-1]*Dx[1][0]+poleA[pixel+1][radek-1]*Dx[2][0]+
 poleA[pixel-1][radek-0]*Dx[0][1]+poleA[pixel-0][radek-0]*Dx[1][1]+poleA[pixel+1][radek-0]*Dx[2][1]+ 
 poleA[pixel-1][radek+1]*Dx[0][2]+poleA[pixel-0][radek+1]*Dx[1][2]+poleA[pixel+1][radek+1]*Dx[2][2];

tmpDy=
 poleA[pixel-1][radek-2]*Dy[0][0]+poleA[pixel-0][radek-2]*Dy[1][0]+poleA[pixel+1][radek-2]*Dy[2][0]+
 poleA[pixel-1][radek-1]*Dy[0][1]+poleA[pixel-0][radek-1]*Dy[1][1]+poleA[pixel+1][radek-1]*Dy[2][1]+ 
 poleA[pixel-1][radek-0]*Dy[0][2]+poleA[pixel-0][radek-0]*Dy[1][2]+poleA[pixel+1][radek-0]*Dy[2][2];

poleB[pixel][radek] = sqrt((tmpDx*tmpDx) + (tmpDy*tmpDy));
if(fabs(tmpDy)==0)
tmpDy = 0.0001;
tmpAngle = atan(fabs(tmpDx)/fabs(tmpDy));
thisAngle = (180*(double)tmpAngle)/3.14;
												// uhly
if ( ( (thisAngle <= 22.5) && (thisAngle >= -22.5) ) || (thisAngle >= 157.5) || (thisAngle <= -157.5) )
				poleC[pixel][radek] = 0;
			if ( ( (thisAngle > 22.5) && (thisAngle < 67.5) ) || ( (thisAngle < -112.5) && (thisAngle > -157.5) ) )
				poleC[pixel][radek] = 45;
			if ( ( (thisAngle > 67.5) && (thisAngle < 112.5) ) || ( (thisAngle < -67.5) && (thisAngle > -112.5) ) )
			poleC[pixel][radek] = 90;
			if ( ( (thisAngle > 112.5) && (thisAngle < 157.5) ) || ( (thisAngle < -22.5) && (thisAngle > -67.5) ) )
			poleC[pixel][radek] = 135;

							}
		};
/*****************************************************/
 //nom-maximum suppression
//   for (radek = 2; radek < Ymax-2; radek++)
//	  	{ 
//		
//		 	for (pixel = 2; pixel < Xmax-2 ; pixel++)
//				{
//				 if(poleC[pixel][radek] == 0)
//				 	{
//					 	if(  poleB[pixel][radek] < poleB[pixel-1][radek] || poleB[pixel][radek] < poleB[pixel+1][radek]  )
//						  {
//						   poleB[pixel][radek] = 0;
//						  }
//					}
//
//					if(poleC[pixel][radek] == 45)
//				 	{
//					 	if(  poleB[pixel][radek] < poleB[pixel-1][radek-1] || poleB[pixel][radek] < poleB[pixel+1][radek+1]  )
//						  {
//						   poleB[pixel][radek] = 0;
//						  }
//					}
//
//					if(poleC[pixel][radek] == 90)
//				 	{
//					 	if(  poleB[pixel][radek] < poleB[pixel][radek-1] || poleB[pixel][radek] < poleB[pixel][radek+1] )
//						  {
//						   poleB[pixel][radek] = 0;
//						  }
//					}
//
//					if(poleC[pixel][radek] == 135)
//				 	{
//					 	if(  poleB[pixel][radek] < poleB[pixel+1][radek-1] || poleB[pixel][radek] < poleB[pixel-1][radek+1]  )
//						  {
//						   poleB[pixel][radek] = 0;
//						  }
//					}
//				}
//		};
		Tlow = 20;
		Thigh = 30;
															  // Double tresholding
		for (radek = 2; radek < Ymax-2; radek++)
	  	{ 
		
		 	for (pixel = 2; pixel < Xmax-2 ; pixel++)
				{
				 if(poleB[pixel][radek] > Thigh)
				 {
				 poleB[pixel][radek] = 63;
				 }

				 if((poleB[pixel][radek] <= Thigh) && (poleB[pixel][radek] > Tlow) )
				 {
				 poleB[pixel][radek] = 0;
				 }

				 if(poleB[pixel][radek] < Tlow)
				 {
				 poleB[pixel][radek] = 0;
				 }
				}
		 }

		 	for (radek = 2; radek < Ymax-2; radek++)		// hystereze
	  	{ 
		
		 	for (pixel = 2; pixel < Xmax-2 ; pixel++)
				{
				 if(poleB[pixel][radek] == 30)
				 	{	 poleB[pixel][radek] = 0;

					 if((poleB[pixel-1][radek-1] ==63) ||(poleB[pixel][radek-1] ==63) ||(poleB[pixel+1][radek-1] ==63) ||
/*3x3 hleda hranu*/ 	(poleB[pixel-1][radek] ==63) 								  ||(poleB[pixel+1][radek] ==63) ||
						(poleB[pixel-1][radek+1] ==63) ||(poleB[pixel][radek+1] ==63) ||(poleB[pixel+1][radek+1] ==63) )
						{
						 poleB[pixel][radek] = 63;
						}
//						if((poleB[pixel-1][radek-1] ==30) ||(poleB[pixel][radek-1] ==30) ||(poleB[pixel+1][radek-1] ==30) ||
///*nasel polohranu*/ 	(poleB[pixel-1][radek] ==30) 								  ||(poleB[pixel+1][radek] ==30) ||
//						(poleB[pixel-1][radek+1] ==30) ||(poleB[pixel][radek+1] ==30) ||(poleB[pixel+1][radek+1] ==30) )
//						{
//						 poleB[pixel][radek] = 63;						
//						}

					
					}
				}
		 }
B2A();
GPIO_WriteBit(GPIOB, LED1, (BitAction)1);
}

void borders (void)
{int pixel,radek;

  for (radek = 0; radek < Ymax-2; radek++)		
	{	for (pixel = 0; pixel < Xmax-2 ; pixel++)
				{if(poleA[pixel][radek]!= 63) poleA[pixel][radek]=0;}}


   	 	for (radek = 2; radek < Ymax-2; radek++)	
	  	{ 
		
		 	for (pixel = 2; pixel < Xmax-2 ; pixel++)
			{	poleC[pixel][radek] = 0;
				// levy horni roh
      			if((poleA[pixel][radek]==63)&&(poleA[pixel][radek+1]==63)&&(poleA[pixel][radek+2]==63)&&(poleA[pixel][radek+3]==63)&&(poleA[pixel][radek+4]==63)&&(poleA[pixel][radek+5]==63)&&(poleA[pixel+1][radek]==63)&&(poleA[pixel+2][radek]==63)&&(poleA[pixel+3][radek]==63)&&(poleA[pixel+4][radek]==63)&&(poleA[pixel+5][radek]==63))
					poleC[pixel][radek] = LevyHorni;
						
					// levy dolni roh
      			if((poleA[pixel][radek]==63)&&(poleA[pixel][radek-1]==63)&&(poleA[pixel][radek-2]==63)&&(poleA[pixel][radek-3]==63)&&(poleA[pixel][radek-4]==63)&&(poleA[pixel][radek-5]==63)&&(poleA[pixel+1][radek]==63)&&(poleA[pixel+2][radek]==63)&&(poleA[pixel+3][radek]==63)&&(poleA[pixel+4][radek]==63)&&(poleA[pixel+5][radek]==63))
						poleC[pixel][radek] = LevyDolni;
					
				 // pravy dolni roh
      			if((poleA[pixel][radek]==63)&&(poleA[pixel][radek-1]==63)&&(poleA[pixel][radek-2]==63)&&(poleA[pixel][radek-3]==63)&&(poleA[pixel][radek-4]==63)&&(poleA[pixel][radek-5]==63)&&(poleA[pixel-1][radek]==63)&&(poleA[pixel-2][radek]==63)&&(poleA[pixel-3][radek]==63)&&(poleA[pixel-4][radek]==63)&&(poleA[pixel-5][radek]==63))
						poleC[pixel][radek] = PravyDolni;
					   
					// pravy horni roh
      			if((poleA[pixel][radek]==63)&&(poleA[pixel][radek+1]==63)&&(poleA[pixel][radek+2]==63)&&(poleA[pixel][radek+3]==63)&&(poleA[pixel][radek+4]==63)&&(poleA[pixel][radek+5]==63)&&(poleA[pixel-1][radek]==63)&&(poleA[pixel-2][radek]==63)&&(poleA[pixel-3][radek]==63)&&(poleA[pixel-4][radek]==63)&&(poleA[pixel-5][radek]==63))
						poleC[pixel][radek] = PravyHorni;
					 
			}
  		}

				 	for (radek = 2; radek < Ymax-2; radek++)	
	  	{ 
				 	for (pixel = 2; pixel < Xmax-2 ; pixel++)
					 {	 if(poleC[pixel][radek] == LevyHorni)
					   _LevyHorni(pixel,radek);
		
						if(poleC[pixel][radek] == PravyHorni)
					   _PravyHorni(pixel,radek);

					   if(poleC[pixel][radek] == LevyDolni)
					   _LevyDolni(pixel,radek);

					   if(poleC[pixel][radek] == PravyDolni)
					   _PravyDolni(pixel,radek);

					 }
		}


}
