#ifndef __MAIN_H
#define __MAIN_H



#define TWD 	11
#define TWCK 	12		   // TWI  interface

#define HREF	9
#define VSYNC	10
#define PCK		8

#define LED1  (uint16_t)(1<<13)
#define LED2  (uint16_t)(1<<14)		//GPIOB
#define LED3 (uint16_t)(1<<15)

#define Xmax 320
#define Ymax 200

#define LevyHorni 1
#define LevyDolni 3
#define PravyHorni 2
#define PravyDolni 4

#define LH2 8
#define PH2 7
#define LD2 6
#define PD2 5

/* Includes ------------------------------------------------------------------*/
#include "stm32f4xx.h"
#include "spi_flash.h"
#include <stdio.h>
#include<math.h>
#include<stdio.h>
#include<rt_sys.h>
#include<string.h>
/* --------------------------------------------------------------------------- */
void posli_objekt(void);
void line(u8,u16,u8,u16,u8);
void USART_SendString(USART_TypeDef * ,char * );
void cekej_na_tlacitko(void);
void start(void);
u8 detect(void);
void vypis_objekt(u8); //vypise souradnice detekovanych objektu
void vypis(void);	   // vypise vsechny rohy
void _LevyHorni(u16 , u8 );		 // funkce pro urcovani rohu
void _LevyDolni(u16 , u8 );		 // funkce pro urcovani rohu
void _PravyHorni(u16 , u8 );	// funkce pro urcovani rohu
void _PravyDolni(u16 , u8 );	// funkce pro urcovani rohu
u8 nextver(u8,u8);				//bullshit
u8 nexthor(u8,u8);				//bullshit
void TimingDelay_Decrement(void);
void Delay(__IO uint32_t nTime);
void LEDinit(void);
void CAMio(void);
void USART_Inicializace(void);
void USART6_Inicializace(void);
void USART1_Inicializace(void);
void INT_Init(void);
static __IO uint32_t TimingDelay;
void delay(void);
uint32_t BTN_Get(void);
void CAM_Read(void);
void CamInit(void);
void greyscale(void);		// prevede z pricoziho formatu(poleA, poleB) na greyscale (poleA)
void posli_poleA(void);
void posli_poleC(void);
void B2A(void);
 void upload_poleA(void); // zalohuje poleA na 000
 void download_poleA(void); // nahraje ze zalohy poleA do poleB
void canny(void);		   // detekuje hrany pouziva pole A,B,C
extern void borders(void);	//detekuje rohy a umisti do poleB
extern int on;			   // useless
extern int poslat;
extern u8 adamove_data;
extern uint8_t poleA[Xmax][Ymax];
extern uint8_t poleB[Xmax][Ymax];
extern uint8_t poleC[Xmax][Ymax];
extern char eee[50];
extern u8 mereni[15];
extern u8 stavCtverec;
extern u8 stavZnacka;
void univerzalni_mod(void);
void cool_mod(void);

#endif 
